/* VorbisComments.h
 **
 ** This program is distributed under the GNU General Public License, version 2.
 ** A copy of this license is included with this source.
 **
 ** Copyright 2001, Warren Spits <spits@cyberdude.com>
 **
 ** A class that holds value tag pairs.
 **/


#ifndef VORBISCOMMENTS_H_INCLUDED
#define VORBISCOMMENTS_H_INCLUDED

#include <codec.h>

class VorbisComments  
{
public:
	static bool isValidValue(const char *value);
	static bool isValidName(const char *name);
	void modifyTag(unsigned int item, const char *name, const char *value);
	void swapPos(unsigned int pos1, unsigned int pos2);
	void store(vorbis_comment *vc) const;
	void retrieve(const vorbis_comment * vc);
	void removeAll();

	VorbisComments();
	virtual ~VorbisComments();

	unsigned int getCount() const;
	char *getValue(char * name) const;
	char *getValue(unsigned int item) const;
	char *getName(unsigned int item) const;

	void addTag(const char *name, const char *value);
	void removeTag(unsigned int item);
	void removeTag(const char * name);

private:
	struct tag
	{
		char *name;
		char *value;
	};

	unsigned int allocated;
	unsigned int count;
	tag *tags;
};

#endif // VORBISCOMMENTS_H_INCLUDED
